package ru.ulstu.report.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import ru.ulstu.report.model.ReportListForm;
import ru.ulstu.report.service.ReportPeriodService;
import ru.ulstu.report.service.ReportService;

@Controller
@RequestMapping("report")
public class ReportController {
    private final ReportService reportService;
    private final ReportPeriodService reportPeriodService;

    public ReportController(ReportService reportService,
                            ReportPeriodService reportPeriodService) {
        this.reportService = reportService;
        this.reportPeriodService = reportPeriodService;
    }

    @GetMapping("reportList")
    public String getReportPeriods(Model model) {
        model.addAttribute("reportListForm", new ReportListForm());
        model.addAttribute("reportPeriods", reportPeriodService.getReportPeriods());
        model.addAttribute("canCreate", false);
        return "report/reportList";
    }

    @PostMapping("reportList")
    public String getReportPeriods(ReportListForm reportListForm, Model model) {
        model.addAttribute("reportListForm", reportListForm);
        model.addAttribute("reportPeriods", reportPeriodService.getReportPeriods());
        model.addAttribute("reports", reportService.getReports(reportListForm.getReportPeriod()));
        model.addAttribute("canCreate", reportService.canCreateReport(reportListForm.getReportPeriod()));
        return "report/reportList";
    }
}
